(function () {
    "use strict";

    var $ = jQuery.noConflict();

    var formVerifoneHosted = $("form.woocommerce-checkout, form.wc-block-checkout__form");

    var place_order_button = null;
    if ($("#place_order,.wc-block-components-checkout-place-order-button").length > 0) {
        place_order_button = $("#place_order,.wc-block-components-checkout-place-order-button").text();
    }

    function verifoneIframePay() {
        if ($("#payment_method_verifone_hosted_cart").is(':checked') || $("[name='radio-control-wc-payment-method-options']:checked").val() === 'verifone_hosted_cart') {
            $('#tco_inline_error').html('');
            $('#place_order').attr('disabled', true);
            $('#place_order').html(place_order_button);

            var appendTo = $(".wc_payment_method .payment_method_verifone_hosted_cart, [name='radio-control-wc-payment-method-options']:checked");
            if ($('#payment_processing_loader').length) {
                $('#payment_processing_loader').remove();
            }

            $('<div id="payment_processing_loader">'+VERIFONE_CREATING_CHECKOUT+'</div>').appendTo(appendTo);

            if ($("[name='payment_method'", formVerifoneHosted).length === 0)
                $('<input type="hidden" name="payment_method" value="verifone_hosted_cart" />').appendTo(formVerifoneHosted);

            var tco_ajax_url;
            var tco_data;
            if ($("form.wc-block-checkout__form").length) {
                tco_ajax_url = VERIFONE_IFRAME_CHECKOUT_URL;
                tco_data = formVerifoneHosted.serialize();
            } else if (formVerifoneHosted.length) {
                tco_ajax_url = wc_checkout_params.checkout_url;
                tco_data = formVerifoneHosted.serialize();
            } else if ($('form#order_review').length) {
                tco_ajax_url = wc_checkout_params.wc_ajax_url
                    .toString()
                    .replace('wc-ajax', 'wc-api')
                    .replace('%%endpoint%%', 'verifone_iframe_handle_payment_request');
                tco_data = $('form#order_review, form.wc-block-checkout__form').serialize();
            }

            $.ajax({
                type: 'POST',
                data: tco_data,
                url: tco_ajax_url,
                success: function (response) {
                    if ("undefined" !== typeof response.info) response = response.info;

                    if (response.result === "success") {
                        if (typeof response.payload !== "undefined") {
                            var payload = JSON.parse(response.payload);
                            if ($('#payment_form_container').length) {
                                $('#payment_form_container').remove();
                            }

                            if ($('#payment_processing_loader').length) {
                                $('#payment_processing_loader').remove();
                            }

                            var appendTo = $('.wc_payment_method .payment_method_verifone_hosted_cart');
                            if ($("[name='radio-control-wc-payment-method-options']:checked").length > 0)
                                appendTo = $("[name='radio-control-wc-payment-method-options']:checked").closest('.wc-block-components-radio-control-accordion-option');

                            $('<div id="payment_form_container"></div>').appendTo(appendTo);

                            function loadIframe(src, containerId) {
                                var script = document.createElement('script');
                                script.src = src;
                                script.async = true;
                                document.getElementById(containerId).append(script);
                            }

                            loadIframe(
                                payload.url,
                                'payment_form_container'
                            );
                            removeIframeBorder();
                        } else if (typeof response.redirect !== "undefined") {
                            window.location.href = response.redirect;
                        }
                    }
                    if (response.result === "failure") {
                        if (response.step !== "undefined") {
                            var notice_wrapper = $('.woocommerce-notices-wrapper,.wc-block-components-notices').first();
                            notice_wrapper.empty();
                            notice_wrapper.append('<ul class="woocommerce-error" role="alert"><li>' + response.messages + '</li> </ul>');
                            $("html, body").animate({ scrollTop: 0 }, 1500);
                        } else {
                            $('#tco_inline_error').html(response.messages);
                            $('#place_order').attr('disabled', false);
                        }
                    }
                },
                error: function (response, data) {
                    console.error("Error response: " + response + " && data: " + data);
                    $('#place_order').attr('disabled', false);
                    return false;
                },
                complete: function (xhr, status) {
                    $('#place_order').attr('disabled', false);
                }
            });
        } else {
            if (formVerifoneHosted.length) {
                formVerifoneHosted.submit();
            } else if ($('form#order_review, form.wc-block-checkout__form').length) {
                $('form#order_review, form.wc-block-checkout__form').submit();
            }
        }
    }

    function prepareVerifoneIframe(e) {
        if ($("#payment_method_verifone_hosted_cart").is(':checked') || $("#radio-control-wc-payment-method-options-verifone_hosted_cart").is(':checked')) {
            e.preventDefault();
            e.stopPropagation();
            verifoneIframePay();
            return false;
        } else {
            return true;
        }
    }

    function handlePayButtonClick(e) {
        if ($("[name='radio-control-wc-payment-method-options']:checked").val() === 'verifone_hosted_cart') {
            e.preventDefault();
            e.stopPropagation();
            verifoneIframePay();
            return false;
        } else {
            return true;
        }
    }

    $(document).on("change", "form[name='checkout'], form[name='checkout'] input[name='payment_method'], form[id='order_review'] input[name='payment_method'], [name='radio-control-wc-payment-method-options']", function () {
        wooVerifoneHostedInit();
    });

    var checkDocumentLoadedInterval = setInterval(function () {
        if (document.readyState === 'complete') {
            formVerifoneHosted = $("form.woocommerce-checkout, form.wc-block-checkout__form")
            clearInterval(checkDocumentLoadedInterval);
            wooBlocksVerifoneHostedInit();
            wooVerifoneHostedInit()
        }
    }, 300);

    function wooBlocksVerifoneHostedInit() {
        if ($("[name='radio-control-wc-payment-method-options']:checked").val() === 'verifone_hosted_cart') {
            $("button.wc-block-components-checkout-place-order-button").off('click', handlePayButtonClick).on('click', handlePayButtonClick);
        } else {
            $("button.wc-block-components-checkout-place-order-button").off('click', handlePayButtonClick);
        }
    }

    function wooVerifoneHostedInit() {
        if ($("#payment_method_verifone_hosted_cart").is(':checked')) {
            $("button[name='woocommerce_checkout_place_order']").off('click', prepareVerifoneIframe).on('click', prepareVerifoneIframe);
        } else {
            $("button[name='woocommerce_checkout_place_order']").off('click', prepareVerifoneIframe);
        }
    }

    function removeIframeBorder() {
        var iframe = $('#payment_form_container').find('iframe');
        if (iframe.length) {
            iframe.css({ 'border': 'none' });
            return;
        } else {
            setTimeout(removeIframeBorder, 150)
        }
    }
})();