(function () {
    "use strict";

    var isBlocksVerifoneJs = "undefined" !== typeof wc && "undefined" !== typeof wc.blocksComponents;
    var publicKeyAlias;
    var encrypted;
    var isCardinalSetup = false;
    var jwt;
    var threeDsLookupData;
    var ccaJwt;
    var $ = jQuery.noConflict();
    var formVerifoneJs = $('form.woocommerce-checkout, form.wc-block-checkout__form');

    function verifoneJsCall() {
        if (formVerifoneJs.length || $('form#order_review').length) {
            $('#verifone_error').html('').hide();
            $('#place_order').attr('disabled', true);

            if (formVerifoneJs.length) {
                if ($("#payment_method_verifone_inline_cart,#radio-control-wc-payment-method-options-verifone_inline_cart").is(':checked')) {
                    $.ajax({
                        type: 'GET',
                        url: verifoneKeyUrl,
                        success: function (response) {
                            if ('undefined' !== typeof response.error) {
                                $('#verifone_error').html(response.error).get(0).scrollIntoView();
                            } else {
                                let card = {
                                    "cardNumber": $('[name="verifone-card-number"]', '#wc-verifone-cc-form').val(),
                                    "expiryMonth": $('[name="verifone-card-expiry"]', '#wc-verifone-cc-form').val().split("/")[0],
                                    "expiryYear": $('[name="verifone-card-expiry"]', '#wc-verifone-cc-form').val().split("/")[1],
                                    "cvv": $('[name="verifone-card-cvc"]', '#wc-verifone-cc-form').val()
                                };

                                if (!card.cardNumber || !card.expiryMonth || !card.expiryYear || !card.cvv) {
                                    $('#verifone_error').html("Enter card details").get(0).scrollIntoView();
                                    $('#place_order').attr('disabled', false);
                                    return;
                                }

                                verifone.encryptCard(card, response.info.public_key).then((encryptedData) => {
                                    publicKeyAlias = response.info.public_key_alias;
                                    encrypted = encryptedData;

                                    if (verifone3DSEnabled)
                                        verifoneTokenCreate();
                                    else
                                        verifoneAjaxSubmit();
                                })
                            }
                        },
                        error: function (response, data) {
                            $('#place_order').attr('disabled', false);
                            console.error("Error response: " + response + " && data: " + data);
                            return false;
                        }
                    });
                }
            }
        }
    }

    function isDomReadyForVerifoneInlineJs() {
        if ($("#payment_method_verifone_inline_cart,#radio-control-wc-payment-method-options-verifone_inline_cart").is(':checked')) {
            if (formVerifoneJs.length) {
                formVerifoneJs.unbind('submit');
                formVerifoneJs.on('submit', bindVerifoneInline);
                moveVerifoneJsWrapper();
            } else if ($('form#order_review').length) {
                $("form#order_review").unbind('submit');
                $("form#order_review").on('submit', bindVerifoneInline);
            }
            $("#verifone_wrapper").show();
        } else {
            formVerifoneJs.off('submit', bindVerifoneInline);
            $("form#order_review").off('submit', bindVerifoneInline);
            $("#verifone_wrapper").hide();
        }

        if(isBlocksVerifoneJs)
            wooBlocksVerifoneJsInit();
    }

    function moveVerifoneJsWrapper() {
        let parent = $("#payment_method_verifone_inline_cart:checked, #radio-control-wc-payment-method-options-verifone_inline_cart__label").closest(".wc_payment_method.payment_method_verifone_inline_cart, .wc-block-components-radio-control-accordion-option");

        if(parent.length)
            $("#verifone_wrapper").appendTo(parent);
    }

    function getOrderAmount() {
        let orderReview = document.querySelector(".woocommerce-checkout-review-order");

        if (orderReview) {
            let orderTotalElement = orderReview.querySelector(".order-total .woocommerce-Price-amount");

            if (orderTotalElement) {
                let orderTotalText = orderTotalElement.textContent;
                let orderTotal = parseFloat(orderTotalText.replace(/[^0-9.,]/g, "").replace('.', ''));
                return orderTotal;
            }
        }
    }

    function verifoneErrorShow(error) {
        $('#verifone_error').html(error).show();
        let targetOffset = $("#verifone_error").offset().top - 30;
        $(document).scrollTop(targetOffset);
        $('#place_order').attr('disabled', false);
    }

    $(document).on('ready', function () {
        formVerifoneJs = $('form.woocommerce-checkout, form.wc-block-checkout__form');
        $("#payment_method_verifone_inline_cart").removeAttr("checked")

        if ($('form#add_payment_method').length || formVerifoneJs.length || $('form#order_review').length) {
            isDomReadyForVerifoneInlineJs();
            moveVerifoneJsWrapper();
        }
    });

    $(document).on("change", "form[name='checkout'] input[name='payment_method'], [name='radio-control-wc-payment-method-options']", function () {
        isDomReadyForVerifoneInlineJs();
    });

    function wooBlocksVerifoneJsInit() {
        moveVerifoneJsWrapper();

        if ($("[name='radio-control-wc-payment-method-options']:checked, #payment_method_verifone_inline_cart:checked").val() === 'verifone_inline_cart') {
            $("button.wc-block-components-checkout-place-order-button").unbind('click');
            $("button.wc-block-components-checkout-place-order-button").on('click', bindVerifoneInline);

            $("#verifone_wrapper").show();
        } else {
            $("button.wc-block-components-checkout-place-order-button").off('click', bindVerifoneInline);
            $("#verifone_wrapper").hide();
        }
    }

    var checkVerifoneJsDocumentLoadedInterval = setInterval(function () {
        if (document.readyState === 'complete') {
            formVerifoneJs = $("form.woocommerce-checkout, form.wc-block-checkout__form");
            isBlocksVerifoneJs = "undefined" !== typeof wc && "undefined" !== typeof wc.blocksComponents;
            clearInterval(checkVerifoneJsDocumentLoadedInterval);

            if(isBlocksVerifoneJs)
                wooBlocksVerifoneJsInit();
        }
    }, 300);

    $(document).on("change", "form[id='order_review'] input[name='payment_method']", function () {
        isDomReadyForVerifoneInlineJs();
    });

    function bindVerifoneInline(e) {
        e.preventDefault();
        e.stopPropagation();
        verifoneJsCall();
        return false;
    }

    function verifoneAjaxSubmit() {
        const formData = formVerifoneJs.find('input:not(#verifone-card-number,#verifone-card-expiry,#verifone-card-cvc),textarea,select').serializeArray();

        formData.push({ name: 'key_alias', value: publicKeyAlias });
        formData.push({ name: 'encrypted', value: encrypted });

        if (threeDsLookupData) formData.push({ name: 'three_ds_lookup_data', value: JSON.stringify(threeDsLookupData) });
        if (ccaJwt) formData.push({ name: 'cca_jwt', value: ccaJwt });

        let ajaxUrl;
        if (isBlocksVerifoneJs)
            ajaxUrl = verifoneJsBlocksCheckoutUrl;
        else
            ajaxUrl = wc_checkout_params.checkout_url;

        $.ajax({
            type: 'POST',
            data: formData,
            url: ajaxUrl,
            success: function (response) {
                if ('undefined' !== typeof response.info)
                    response = response.info;

                if ('undefined' !== typeof response.error) {
                    verifoneErrorShow(response.error);
                    return false;
                } else {
                    window.location.replace(response.redirect);
                }
            },
            error: function (response, data) {
                verifoneErrorShow(response);
                return false;
            }
        });
    }

    function verifoneTokenCreate() {
        $.ajax({
            type: "POST",
            data: {},
            url: verifone3DSJwtUrl,
            success: function (response) {
                if ('undefined' !== typeof response.error) {
                    verifoneErrorShow(response.error);
                    return;
                }

                jwt = response.info;

                cardinalSetup();
            },
            error: function (response, data) {
                verifoneErrorShow(response);
                return false;
            }
        });
    }

    function verifoneThreeDSLookup(sessionId) {
        $.ajax({
            type: "POST",
            data: {
                sessionId: sessionId,
                amount: getOrderAmount(),
                billing_first_name: $('#billing_first_name').val(),
                billing_last_name: $('#billing_last_name').val(),
                billing_address_1: $('#billing_address_1').val(),
                billing_city: $('#billing_city').val(),
                billing_country: $('#billing_country').val(),
                email: $('#billing_email').val(),
                encrypted: encrypted,
                key_alias: publicKeyAlias,
            },
            url: verifone3DSLookup,
            success: function (response) {
                if ('undefined' !== typeof response.error) {
                    verifoneErrorShow(response.error);
                    return;
                }

                threeDsLookupData = response.info;

                if (threeDsLookupData.acs_url)
                    Cardinal.continue('cca',
                        {
                            "AcsUrl": threeDsLookupData.acs_url,
                            "Payload": threeDsLookupData.payload,
                        },
                        {
                            "OrderDetails": {
                                "TransactionId": threeDsLookupData.transaction_id
                            }
                        }
                    );
                else
                    verifoneAjaxSubmit();
            },
            error: function (response, data) {
                verifoneErrorShow(response);
                return false;
            }
        });
    }

    function cardinalSetup() {
        Cardinal.configure({});

        if (!isCardinalSetup) {
            Cardinal.on('payments.setupComplete', function (setupCompleteData) {
                verifoneThreeDSLookup(setupCompleteData.sessionId);
            });

            Cardinal.on('payments.validated', function (decodedResponseData, responseJWT) {
                if ("SUCCESS" === decodedResponseData.ActionCode) {
                    ccaJwt = responseJWT;
                    verifoneAjaxSubmit();
                } else {
                    verifoneErrorShow('Payment cannot be made with this card.');
                }
            });

            isCardinalSetup = true;
        }

        Cardinal.setup("init", { jwt: jwt });
    }
})();